#include <bits/stdc++.h>
using namespace std;
int main()
{

int t,q=0;

cin>>t;

long long a[t][40000000];

if(t==1)
{
    int n;
    cin>>n;
    int b[n],c[n];
    for(int i=0;i<n;i++)
    {
        cin>>b[i];
        if(b[i]!=pow(2,i))
        {
            q++;
        }
    }
    sort(b,b+n);
    if(q>0)
    {

    }
    else
    {
        cout<<n-1<<" ";
        for(int i=0;i<n-1;i++)
        {
            cout<<i<<" ";
        }
    }
}
else
{
int f[t];
for(int i=0;i<t;i++)
{
    int n;
    long long s[n];
    cin>>n;
    f[i]=n;
    for(int j=0;j<n;j++)
    {
        cin>>s[j];
    }
}
for(int i=0;i<t;i++)
{
        cout<<f[i]-1<<" ";
        for(int i=0;i<f[i]-1;i++)
        {
            cout<<i<<" ";
        }
        cout<<endl;
}
}

return 0;
}
